-- Ouphoria v0.1 pre-alpha preprocessor
-- Created by Jrgen Jnes

-------------------------------------------------------------------------------------------------
-- FILE I/O ROUTINES
-------------------------------------------------------------------------------------------------
function load_text (sequence filename)
integer handle
object buffer, text
text = {}

handle = open (filename, "r")
if handle != -1 then
	while 1 do
		buffer = gets (handle)
		if equal (buffer, -1) then
			for Index = 1 to length (text) do
				if text[Index][length (text[Index])] = '\n' then
					text[Index] = text[Index][1..length (text[Index]) - 1]
				end if
			end for
			close (handle)
			return text
		end if
		text = append (text, buffer) 
	end while
	close (handle)
else
	puts (1, "can't open " & filename & "\n")
	abort (0)
end if
end function
-------------------------------------------------------------------------------------------------
procedure save_text (sequence filename, sequence text)
integer handle
for Index = 1 to length (text) do
	text[Index] &= '\n'
end for
handle = open (filename, "w")
if handle != -1 then
	for Index = 1 to length (text) do
		puts (handle, text[Index])
	end for
else
	puts (1, "can't open " & filename & " \n")
	abort (0)
end if
close (handle)
end procedure
-------------------------------------------------------------------------------------------------
-- VERY UGLY PARSER
-------------------------------------------------------------------------------------------------
constant 
    Delimeters = {' ' , '+' , '-' , '*' , '/' , '(' , ')' , '[' , ']' , '{',
                  '}' , '&' , '<' , '>' , '=' , ',' , '.' , '\"' }--, '\n'},
-------------------------------------------------------------------------------------------------
function ParseLine1 (sequence Line)
integer Beginning
sequence Parsed

Parsed = {}
Beginning = 0

for Index = 1 to length (Line) do
    if Index = 1 and
       find (Line[Index], Delimeters) = 0 then
        Beginning = 1
    elsif find (Line[Index], Delimeters) != 0 and 
          Beginning = 0 then
        Parsed = append (Parsed, {Line[Index]})
        Beginning = Index + 1
    elsif find (Line[Index], Delimeters) != 0 and
          Beginning != 0 then
        Parsed = append (Parsed, Line[Beginning..Index - 1])                
        Parsed = append (Parsed, {Line[Index]})
        Beginning = Index + 1
    elsif Index = length (Line) then        
        Parsed = append (Parsed, Line[Beginning..Index])
    end if
end for

Line = {}
for Index = 1 to length (Parsed) do
    if not equal (Parsed[Index], {}) then
        Line = append (Line, Parsed[Index])
    end if
end for

return Line
end function
-----------------------------------------------------------------------------
function ParseLine2 (sequence Line)
sequence Parsed
integer Beginning, I
Parsed = {}
Beginning = 0

for Index = 1 to length (Line) do
    if Line[Index][1] = '\"' and
       Beginning = 0 then
        Beginning = Index
        Parsed = append (Parsed, "\"")
    elsif Line[Index][1] = '\"' and
          Beginning != 0 then
        Parsed[length (Parsed)] &= Line[Index]
        Beginning = 0
    elsif Beginning != 0 then
        Parsed[length (Parsed)] &= Line[Index]
    else
        Parsed = append (Parsed, Line[Index])
    end if
end for

for Index = 1 to length (Parsed) do
    if length (Parsed) > Index and
       equal (Parsed[Index] & Parsed[Index + 1], "--") then
        Parsed = Parsed[1..Index - 1]
    end if
end for

if not equal (Parsed, {}) then 
	I= 1
	while 1 do
		if equal (Parsed[I][1], ' ') then
			Parsed = Parsed[1..I - 1] & Parsed[I + 1..length (Parsed)]
    		I-= 1
    	end if
		if I = length (Parsed) then exit end if
		I += 1
	end while
end if
return Parsed
end function
-------------------------------------------------------------------------------------------------
function parse (sequence line)
line = ParseLine1 (line)
line = ParseLine2 (line)
return line
end function
-------------------------------------------------------------------------------------------------
function unparse (sequence line)
sequence unparsed_line
unparsed_line = {}

for Index = 1 to length (line) do
	unparsed_line &= line[Index]
	if length (line[Index]) != 1 then 
		unparsed_line &= ' ' 
	end if
end for

return unparsed_line
end function
-------------------------------------------------------------------------------------------------
-- PROCCESOR
-------------------------------------------------------------------------------------------------
function get_func_end (sequence line, integer pos)
integer depth
depth = 0

for i = pos to length (line) do
	if equal (line[i], "(") then
		depth += 1
	elsif equal (line[i], ")") then
		depth -= 1
	end if
	if depth = 0 then
		return i
	end if
end for

end function
-------------------------------------------------------------------------------------------------
function compile_subscript (sequence line, integer pos)
integer depth
depth = 0

for i = pos to length (line) do
	if equal (line[i], "[") then
		depth += 1
	elsif equal (line[i], "]") then
		depth -= 1
	end if
	if depth = 0 then
		return i
	end if
end for

end function
-------------------------------------------------------------------------------------------------
function compile_expression (sequence line, integer pos)
sequence compiled
integer i, ssend
compiled = {"{", line[pos], ","}
i = pos + 1

while 1 do
	if i > length (line) then
		exit
	end if
	if equal (line[i], ".") then
		compiled &= {"\"" & line[i + 1] & "\""} & {","}
		i += 2
	elsif equal (line[i], "[") then
		ssend = compile_subscript (line, i)
		compiled = compiled & line[i + 1..ssend - 1] & {","}
		i = ssend + 1
	else
		exit
	end if
end while

compiled[length (compiled)] = "}"

return {compiled, i - 1}
end function
-------------------------------------------------------------------------------------------------
constant function_delimeters = {"+", "-", "*", "\"", "&",
                                "=", "<", ">",
                                "[", "{", ",",
                                "and", "or", "if", "?"}

sequence current_routine_name
integer compile_file_id
current_routine_name = {}

-------------------------------------------------------------------------------------------------
procedure init_compile_line (integer id)
compile_file_id = id
end procedure
-------------------------------------------------------------------------------------------------
function replace (object what, object with_what, sequence line)
if find (what, line) then
	line[find (what, line)] = with_what
end if
return line
end function
-------------------------------------------------------------------------------------------------
function concate (sequence line)
sequence unparsed_line
unparsed_line = {}

for Index = 1 to length (line) do
	unparsed_line &= line[Index]
end for

return unparsed_line
end function
-------------------------------------------------------------------------------------------------
function compile_include_statement (sequence line)
if equal (line[1], "include") then	
	line[2] = concate (line[2..length (line)])
	line = line[1..2]
	line[2] = call_func (compile_file_id, {line[2]})
end if

return line
end function
-------------------------------------------------------------------------------------------------
function compile_routine_declaration (sequence line)
if equal (line[1], "procedure") or
   equal (line[1], "function") then
	line[2..find ("(", line ) - 1] = 
	replace (".", "_", line[2..find ("(", line ) - 1])
	current_routine_name = concate (line[2..find ("(", line) - 1])
	line = line[1..2] & line[find ("(", line )..length (line)]
	line[2] = current_routine_name
end if

return line
end function
-------------------------------------------------------------------------------------------------
function compile_routine_declaration_end (sequence line)
if (equal (line[1], "end") and equal (line[2], "procedure")) or 
   (equal (line[1], "end") and equal (line[2], "function")) then
	line = append (line, sprintf ("assign_method (\"%s\", routine_id (\"%s\"))", {current_routine_name, current_routine_name}))
end if

return line
end function
-------------------------------------------------------------------------------------------------
function compile_property_acesses (sequence line)
sequence compiled_line, compiled_expression
integer i
compiled_line = {}
i = 1

while 1 do
	if equal (line[i], ".") then
		compiled_expression = compile_expression (line, i - 1)
		if not equal (line[compiled_expression[2] + 1], "(") then
			if equal (line[compiled_expression[2] + 1], "=") and
		       not find ("if", line) and
		       not find ("or", line) and
		       not find ("and", line) then
				compiled_line[length (compiled_line)] = "write_property ("
				compiled_line &= compiled_expression[1]
				compiled_line = append (compiled_line, ",")
				compiled_line &= line[compiled_expression[2] + 2..length (line)]
				compiled_line = append (compiled_line, ")")
				i = compiled_expression[2]
				exit
			elsif find (line[i - 2], function_delimeters) or
				  find ("if", line) or
				  find ("or", line) or
				  find ("and", line) then
				compiled_line[length (compiled_line)] = "read_property ("
				compiled_line &= compiled_expression[1]
				compiled_line = append (compiled_line, ")")
				i = compiled_expression[2]
			end if		
		else
			compiled_line = append (compiled_line, line[i])
		end if
	else
		compiled_line = append (compiled_line, line[i])
	end if
		i += 1
	if i = length (line) then 
		exit
	end if
end while

return compiled_line
end function
-------------------------------------------------------------------------------------------------
function compile_routine_calls (sequence line)
sequence compiled_line, compiled_expression
integer i
compiled_line = {}
i = 1

while 1 do
	if equal (line[i], ".") then
		compiled_expression = compile_expression (line, i - 1)
		if equal (line[compiled_expression[2] + 1], "(") then
			if not find (line[i - 2], function_delimeters) and
		       not find ("if", line) and
		       not find ("or", line) and
		       not find ("and", line) then
				compiled_line[length (compiled_line)] = "call_pmethod ("
				compiled_line &= compiled_expression[1]
				compiled_line = append (compiled_line, ",")
				compiled_line = append (compiled_line, "{")
				compiled_line &= line[compiled_expression[2] + 3..length (line)]	
				compiled_line = append (compiled_line, "}")
				compiled_line = append (compiled_line, ")")
				i = compiled_expression[2]
				exit
			elsif find (line[i - 2], function_delimeters) or
				  find ("if", line) or
				  find ("or", line) or
				  find ("and", line) then
				compiled_line[length (compiled_line)] = "call_fmethod ("
				compiled_line &= compiled_expression[1]
				compiled_line = append (compiled_line, ",")
				compiled_line = append (compiled_line, "{")
				compiled_line &= line[compiled_expression[2] + 2..get_func_end (line, compiled_expression[2] + 1) - 1]	
				compiled_line = append (compiled_line, "}")
				compiled_line = append (compiled_line, ")")
				i = get_func_end (line, compiled_expression[2] + 1) - 1
				exit
			end if		
		else
			compiled_line = append (compiled_line, line[i])
		end if
	else
		compiled_line = append (compiled_line, line[i])
	end if
	if i = length (line) then 
		exit
	end if
	i += 1
end while

return compiled_line
end function
-------------------------------------------------------------------------------------------------
function compile_line (sequence line)

line = parse (line)

if equal (line, {}) then 
	return line 
end if

line = compile_include_statement (line)
line = compile_routine_declaration (line)
line = compile_routine_declaration_end (line)

line = prepend (line, " ")
line = append (line, " ")

line = compile_property_acesses (line)
line = compile_routine_calls (line)

line = unparse (line)

return line
end function
-------------------------------------------------------------------------------------------------
-- INTERFACE
-------------------------------------------------------------------------------------------------
	function compile_file_name (sequence FileName)
	if match (".o", FileName) then
		FileName[match (".o", FileName)..match (".o", FileName) + 1] = ".e"
	elsif match (".ox", FileName) then
		FileName[match (".ox", FileName)..match (".ox", FileName) + 2] = ".ex"
	elsif match (".ow", FileName) then
		FileName[match (".ow", FileName)..match (".ow", FileName) + 2] = ".ew"
	elsif match (".oxw", FileName) then
		FileName[match (".oxw", FileName)..match (".oxw", FileName) + 3] = ".exw"
	end if
	return FileName
	end function
-------------------------------------------------------------------------------------------------
global function compile_file (sequence Filename)
sequence FileData

if equal (compile_file_name (Filename), Filename) then 
	return Filename
end if

FileData = load_text (Filename)

for Index = 1 to length (FileData) do
	FileData[Index] = compile_line (FileData[Index])
end for

save_text (compile_file_name (Filename), FileData)

return compile_file_name (Filename)
end function
-------------------------------------------------------------------------------------------------
init_compile_line (routine_id ("compile_file"))
-------------------------------------------------------------------------------------------------
-- MAIN PROGRAM
-------------------------------------------------------------------------------------------------
sequence cmd_line
cmd_line = command_line ()

puts (1, "Ouphoria v0.1 pre-alpha preprocessor\n")
puts (1, "Created by Jrgen Jnes\n\n")

if length (cmd_line) < 3 then
	puts (1, "Error in command line parameters!\n\n")
	abort (0)
end if

puts (1, "Created output file: " & compile_file (cmd_line[3]) & "\n")
